// Word Cloud Example
// Step 1: Acquire, Parse, and Display

String inputTextFile = "waronchristmas.txt";
String [] fileContents;
String rawText;
String [] tokens;
String delimiters = " ,./?<>;:'\"[{]}\\|=+-_()*&^%$#@!~";
int NUM_WORDS = 52000;

HashMap<String, Integer> wordCountSet = 
new HashMap<String, Integer>();

void setup() {
  size(1000, 800);
  background(0);
  // Input and parse text file
  fileContents = loadStrings(inputTextFile);
  rawText = join(fileContents, " ");
  rawText = rawText.toLowerCase();
  tokens = splitTokens(rawText, delimiters);
  // print out the number of tokens found
  println(tokens.length+" tokens found in file: "+inputTextFile);

  wordCountSet = makeWordPairs(tokens);

  //print(wordCountSet);

  
    displayWords(NUM_WORDS);
} // setup()

// display at most num words
void displayWords(int num) {
  // get max
  int max = getMaxWordCount();

  int count = 0; // the number of displayed words
  for (String t : wordCountSet.keySet ()) { 
    int frequency = wordCountSet.get(t);
    float tSize = map(frequency, 1, max, 12, 150);   
    textSize(tSize);
    if (random(100) > 40) {
      fill(random(150, 250), 0, 0, 190);
    } else {
      fill(0, random(150, 250), 0, 190);
    }
    if (count < num) {
      text(t, random(0, width-50), random(20, height));
      count++;
    }
  } // for
}

HashMap<String, Integer> makeWordPairs(String[] words) {
  HashMap<String, Integer> wordPairs = 
    new HashMap<String, Integer>();
  for (String w : words) {
    Integer wordFrequency = wordPairs.get(w);
    if (wordFrequency != null) {
      wordPairs.put(w, wordFrequency+1);
    } else {
      wordPairs.put(w, 1);
    }
  }

  return wordPairs;
}

int getMaxWordCount() {
  int max = 0;
  for (Integer val : wordCountSet.values ()) {
    if (max < val) {
      max = val;
    }
  } 
  return max;
}

